#
# spec file for package translation-update
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           translation-update
BuildRequires:  fdupes
BuildRequires:  gettext
Version:        15.2
Release:        lp152.1.1
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
# Translation updates. Files here should not conflict with
# translation-update-from-translation-update-upstream.
# In case of conflict, the particular translation file is lost.
Source:         translation-update.tar.bz2
Source1:        README
Source2:        COPYING
Source3:        AUTHORS
# WARNING: Before submitting new version, always review "osc diff", fix bad
# language description and update Obsoletes for removed locales.
# Auto-generated by translation-update-upstream supplementary scripts
# upstream-collect.sh + translation-update-upstream-to-translation-update.sh
# (Includes packages that don't correctly update with
# translation-update-upstream and packages that are not rebuilt in
# target project.)
Source4:        translation-update-from-translation-update-upstream-20200601.tar.bz2
# Last minute additions that take precedence over
# translation-update-from-translation-update-upstream. Strings are
# merged in a smart way and existing strings are not lost.
Source5:        translation-update2.tar.bz2
Source6:        translation-update.rpmlintrc
# Supplementary scripts:
# Reset ranslation-update.tar.bz2.
Source100:      reset-translation-update.sh
# Strip all sub-packages from the spec file.
Source101:      translation-update-spec-reset-lang-list.sh
# Generate spec file with needed sub-packages from .build.log from "osc build".
Source102:      translation-update-spec-generate-lang-list.sh
BuildArch:      noarch
Summary:        Translation Updates
License:        GPL-2.0+
Group:          System/Base
# Existed up to SLE 15
Obsoletes:      translation-update-as
# Existed up to SLE 15
Obsoletes:      translation-update-be-latin
# Existed up to SLE 15
Obsoletes:      translation-update-bn_IN
# Existed up to 13.1, but not obsoleted up to Leap 42.1
Obsoletes:      translation-update-ca@valencia
# Existed up to 2014, but not obsoleted up to Leap 42.1
Obsoletes:      translation-update-caValencia
# Existed up to SLE 15
Obsoletes:      translation-update-dz
# Existed up to SLE 15
Obsoletes:      translation-update-en-shaw
# Existed up to SLE 15
Obsoletes:      translation-update-en_CA
# Existed up to SLE 15
Obsoletes:      translation-update-ga
# Existed up to 12.3, but not obsoleted up to Leap 42.1
Obsoletes:      translation-update-ka
# Existed up to SLE 15
Obsoletes:      translation-update-mai
# Existed up to SLE 15
Obsoletes:      translation-update-mk
# Existed up to SLE 15
Obsoletes:      translation-update-nds
# Existed up to SLE 15
Obsoletes:      translation-update-or
# Existed up to SLE 15
Obsoletes:      translation-update-sq
# Existed up to SLE 15
Obsoletes:      translation-update-sr-ije
# Existed up to 13.1, but not obsoleted up to Leap 42.1
Obsoletes:      translation-update-sr@latin
# Existed up to 2014, but not obsoleted up to Leap 42.1
Obsoletes:      translation-update-srLatin
# Existed up to SLE 15
Obsoletes:      translation-update-te
# Existed up to SLE 15
Obsoletes:      translation-update-ug
# Existed up to SLE 15
Obsoletes:      translation-update-zh_HK
# And all these existed up to SLE15 SP1
Obsoletes:      translation-update-ar
Obsoletes:      translation-update-ast
Obsoletes:      translation-update-be
Obsoletes:      translation-update-bg
Obsoletes:      translation-update-bn
Obsoletes:      translation-update-ca
Obsoletes:      translation-update-ca-valencia
Obsoletes:      translation-update-cs
Obsoletes:      translation-update-da
Obsoletes:      translation-update-de
Obsoletes:      translation-update-el
Obsoletes:      translation-update-en
Obsoletes:      translation-update-en_GB
Obsoletes:      translation-update-en_US
Obsoletes:      translation-update-eo
Obsoletes:      translation-update-es
Obsoletes:      translation-update-es_AR
Obsoletes:      translation-update-es_CL
Obsoletes:      translation-update-es_CO
Obsoletes:      translation-update-es_CR
Obsoletes:      translation-update-es_DO
Obsoletes:      translation-update-es_EC
Obsoletes:      translation-update-es_ES
Obsoletes:      translation-update-es_GT
Obsoletes:      translation-update-es_HN
Obsoletes:      translation-update-es_MX
Obsoletes:      translation-update-es_NI
Obsoletes:      translation-update-es_PA
Obsoletes:      translation-update-es_PE
Obsoletes:      translation-update-es_PR
Obsoletes:      translation-update-es_SV
Obsoletes:      translation-update-es_UY
Obsoletes:      translation-update-es_VE
Obsoletes:      translation-update-et
Obsoletes:      translation-update-eu
Obsoletes:      translation-update-fa
Obsoletes:      translation-update-fi
Obsoletes:      translation-update-fr
Obsoletes:      translation-update-fr_CA
Obsoletes:      translation-update-gl
Obsoletes:      translation-update-gu
Obsoletes:      translation-update-he
Obsoletes:      translation-update-hi
Obsoletes:      translation-update-hr
Obsoletes:      translation-update-hu
Obsoletes:      translation-update-ia
Obsoletes:      translation-update-id
Obsoletes:      translation-update-is
Obsoletes:      translation-update-it
Obsoletes:      translation-update-it_IT
Obsoletes:      translation-update-ja
Obsoletes:      translation-update-kk
Obsoletes:      translation-update-km
Obsoletes:      translation-update-kn
Obsoletes:      translation-update-ko
Obsoletes:      translation-update-lt
Obsoletes:      translation-update-lv
Obsoletes:      translation-update-ml
Obsoletes:      translation-update-mr
Obsoletes:      translation-update-nb
Obsoletes:      translation-update-nb_NO
Obsoletes:      translation-update-ne
Obsoletes:      translation-update-nl
Obsoletes:      translation-update-nn
Obsoletes:      translation-update-pa
Obsoletes:      translation-update-pl
Obsoletes:      translation-update-pt
Obsoletes:      translation-update-pt_BR
Obsoletes:      translation-update-pt_PT
Obsoletes:      translation-update-ro
Obsoletes:      translation-update-ru
Obsoletes:      translation-update-sk
Obsoletes:      translation-update-sl
Obsoletes:      translation-update-sr
Obsoletes:      translation-update-sr-latin
Obsoletes:      translation-update-sv
Obsoletes:      translation-update-ta
Obsoletes:      translation-update-th
Obsoletes:      translation-update-tr
Obsoletes:      translation-update-tr_TR
Obsoletes:      translation-update-uk
Obsoletes:      translation-update-vi
Obsoletes:      translation-update-wa
Obsoletes:      translation-update-zh_CN
Obsoletes:      translation-update-zh_TW

%description
This is a set of translation updates that are installed into the
preferred directory, /usr/share/locale-langpack/<locale>/LC_MESSAGES/.

Applications that use gettext correctly can then pick up overridden or
updated translations from this location.

%prep
%setup -n translation-update -a 4
# # These were updated on SLE10 SP1 resp. separately as yast2-trans-{??,??_??}
# rm -fr yast-trans/{ar,bn,ca,cs,de,es,fi,fr,hi,hu,it,ja,ko,nb,nl,pl,pt_BR,ru,sk,ta,zh_CN,zh_TW}
cd ..
mkdir tu2
cd tu2
tar xvf %{S:5}
cd ..

%build
# Merge last minute updates in upstream collected files
shopt -s nullglob
up_dir=../../../translation-update/translation-update
cd ../tu2/translation-update
for PACKAGE in * ; do
  cd $PACKAGE
  for LL in * ; do
    msgfmt --check -o /dev/null $LL/$LL.po || continue
    # ls $up_dir
    up_ll_dir=$up_dir/$PACKAGE/$LL
    up_ll_file=$up_ll_dir/$LL.po
    if [ -f $up_ll_file ]; then
      msgcat --use-first -o tmp.po $LL/$LL.po $up_ll_file \
        && mv tmp.po $up_ll_file \
        || :
    else
      mkdir -p $up_ll_dir
      cp $LL/$LL.po $up_ll_dir
    fi
  done
  cd ..
done

%install
mkdir -p $RPM_BUILD_ROOT%{_datadir}/locale-langpack
# First process translation-update tarball.
shopt -s nullglob
for PACKAGE in * ; do
    if test "$PACKAGE" = translation-update ; then
	continue
    fi
    cd $PACKAGE
    for LNG in * ; do
	cd $LNG
	for PO in *.po ; do
	    if [ ${PO%.po} == $LNG ] ; then
		msgfmt -c -o $PACKAGE.mo $PO
	    else
		msgfmt -c -o ${PO%.$LNG.po}.mo $PO
	    fi
	    if [ -d ${RPM_BUILD_ROOT}%{_datadir}/locale-langpack/$LNG ] ; then
		install -m 644 *.mo ${RPM_BUILD_ROOT}%{_datadir}/locale-langpack/$LNG/LC_MESSAGES
	    else
		install -d ${RPM_BUILD_ROOT}%{_datadir}/locale-langpack/$LNG/LC_MESSAGES
		install -m 644 *.mo ${RPM_BUILD_ROOT}%{_datadir}/locale-langpack/$LNG/LC_MESSAGES
	    fi
	done
	cd ..
    done
    cd ..
done
cd translation-update
# Second process translation-update-from-translation-update-upstream tarball.
# In case of conflict, it will overwrite the previous. (It should contain LCN + upstream fixes together.
for PACKAGE in * ; do
    cd $PACKAGE
    for LNG in * ; do
	cd $LNG
	for PO in *.po ; do

	    # Supplementary scripts make several checks. But if the
	    # downstream po file was already invalid, then update may
	    # still be invalid. Don't fail and ignore such updates.

	    if [ ${PO%.po} == $LNG ] ; then
		if ! msgfmt -c -o $PACKAGE.mo $PO ; then
		    echo "ERROR: $PACKAGE/$LNG/$PO is invalid. Ignoring update."
		    continue
		fi
	    else
		if ! msgfmt -c -o ${PO%.$LNG.po}.mo $PO ; then
		    echo "ERROR: $PACKAGE/$LNG/$PO is invalid. Ignoring update."
		    continue
		fi
	    fi
	    if [ -d ${RPM_BUILD_ROOT}%{_datadir}/locale-langpack/$LNG ] ; then
		install -m 644 *.mo ${RPM_BUILD_ROOT}%{_datadir}/locale-langpack/$LNG/LC_MESSAGES
	    else
		install -d ${RPM_BUILD_ROOT}%{_datadir}/locale-langpack/$LNG/LC_MESSAGES
		install -m 644 *.mo ${RPM_BUILD_ROOT}%{_datadir}/locale-langpack/$LNG/LC_MESSAGES
	    fi
	done
	cd ..
    done
    cd ..
done
cd ..
install -d ${RPM_BUILD_ROOT}%{_defaultdocdir}/%{name}
install -m 644 %{S:1} ${RPM_BUILD_ROOT}%{_defaultdocdir}/%{name}
install -m 644 %{S:2} ${RPM_BUILD_ROOT}%{_defaultdocdir}/%{name}
install -m 644 %{S:3} ${RPM_BUILD_ROOT}%{_defaultdocdir}/%{name}
# For empty subpackages
install -m 644 %{S:2} .

#
# go through valid locales and fail in invalid ones
#
set +x
cd $RPM_BUILD_ROOT%{_datadir}/locale-langpack
for LOCALE in * ; do
	if ! test -d /usr/share/locale/$LOCALE ; then
               echo -n "removing unsupported translation $LOCALE"
               rm -rfv $LOCALE
        fi
done

# FIXME: There are duplicates! Some packages changed its domain and translation-update.tar.bz2 still uses the old one.
%fdupes ${RPM_BUILD_ROOT}

%clean
rm -rf "$RPM_BUILD_ROOT"

%files
%defattr(-,root,root)
%{_defaultdocdir}/%{name}

%changelog
* Tue Jun  2 2020 Stanislav Brabec <sbrabec@suse.com>
- Reset outdated translations, tag as version 20200601
  (bsc#1172337, boo#1172367).
- Drop SLE / Leap discrimination code.
* Thu Mar 28 2019 sbrabec@suse.com
- Refresh from
  translation-update-from-translation-update-upstream-20190328.tar.bz2:
  * Translation updates.
  * Adds 3 language subpackages.
* Wed Nov 28 2018 sbrabec@suse.com
- Set version to 15.1.
- Update to
  translation-update-from-translation-update-upstream-20181127.tar.bz2.
- translation-update-spec-generate-lang-list.sh: Fix Obsoletes
  generator.
* Fri Apr 27 2018 sbrabec@suse.com
- Refresh from
  translation-update-from-translation-update-upstream-20180426.tar.bz2:
  * Update for translation-update-upstream fixes (bsc#1087076).
  * Correct files from meson/ninja based builds.
  * Creates many new sub-packages.
* Tue Apr 10 2018 sbrabec@suse.com
- Refresh from
  translation-update-from-translation-update-upstream-20180410.tar.bz2:
  * Reflect latest package updates (e. g. gtk3, bsc#1087126).
  * Update for translation-update-upstream fixes (bsc#1086036#c13).
  * Package is now SLE 15 specific. Exclude openSUSE-only packages.
  * Renders obsolete several sub-packages (see spec file comments).
* Mon Apr  9 2018 sbrabec@suse.com
- Refresh from
  translation-update-from-translation-update-upstream-20180313.2.tar.bz2:
  * Add upstream eiciel to misc.tlst, remove merged downstream from
    lcn-sle.tlst.
  * Update eiciel (bsc#1087321).
* Wed Mar 28 2018 sbrabec@suse.com
- Refresh from
  translation-update-from-translation-update-upstream-20180313.1.tar.bz2:
  * After fixing of gdm boo#1086036, gdm disappears
    (part of boo#1087338).
* Tue Mar 13 2018 sbrabec@suse.com
- Set version to 15.0.
- Update to
  translation-update-from-translation-update-upstream-20180313.tar.bz2
  (bsc#989505).
- translation-update-spec-generate-lang-list.sh: Use osc lbl.
* Tue Nov  3 2015 sbrabec@suse.com
- Obsolete all language packages that are no longer distributed
  (boo#952855#c41) and add support for it in supplementary scripts
  (translation-update-spec-generate-lang-list.sh,
  translation-update-spec-reset-lang-list.sh).
* Thu Sep  4 2014 sbrabec@suse.cz
- Reset translation-update-from-translation-update-upstream-20140905.tar.bz2.
  * all language subpackages disappear
- translation-update-spec-generate-lang-list.sh:
  Prefer X-Poedit-Language for spec file summary.
* Wed May  7 2014 sbrabec@suse.cz
- Fix for empty tarballs.
- Fix translation-update-generate-lang-list.sh for "@" in locale
  names.
- Rename translation-update-spec-reset-lang-list.sh and
  translation-update-spec-generate-lang-list.sh to make visible its
  relation to the spec file.
* Fri May  2 2014 tchvatal@suse.com
- Rename ca@valencia and sr@latn to caValencia and srLatn to work
  again on Factory.
* Mon Feb 18 2013 sbrabec@suse.cz
- Set version to 12.3.
- Added support for auto-generated
  translation-update-from-translation-update-upstream tarball
  with translation updates and added
  translation-update-from-translation-update-upstream-20130214.tar.bz2
- Added support for last minute translations
  (translation-update2.tar.bz2).
- Added two supplementary scripts that allow to generate package
  list dynamically (translation-update-reset-lang-list.sh,
  translation-update-generate-lang-list.sh).
- Added translation-update.rpmlintrc.
- Small improvements of %%build and %%install to run faster with
  cleaner log.
* Thu Apr 14 2011 ke@suse.de
- Increase version number to 12.1.
- Reset all translation-update-* packages for 12.1 using
  reset-translation-update.sh.
* Wed Mar 30 2011 ke@suse.de
- increase version number to 11.4.
- translation updates mostly because of webyast, but other software
  components such as zypper were also affected:
  da de es fi fr gl hr hu it ja km lt nb nl pl ro ru wa pt_BR.
* Fri May 14 2010 ke@suse.de
- reset-translation-update.sh: Fix sed script.
* Wed Jan 20 2010 coolo@novell.com
- increase version number to 11.3
- remove authors from description
* Tue Oct 20 2009 ke@suse.de
- Increase version number.
* Mon Mar 16 2009 ke@suse.de
- Reset all translation-update-* packages for 11.2.
- reset-translation-update.sh: New helper script.
* Wed Feb 18 2009 ke@suse.de
- Also add Wallon (wa) trying to fix bnc#438980.
- Add Punjabi (pa).
* Tue Feb 17 2009 ke@suse.de
- General post-GA translation update (bnc#464470).
* Mon Aug 18 2008 ke@suse.de
- Also reset cs and pl (for 11.1); see bnc#404073,
  bnc#399561. bnc#402551, bnc#402885, and bnc#407285.
* Fri Jan 11 2008 ke@suse.de
- Reset translations for openSUSE 11.0; see #353229.
* Fri Jan 11 2008 ke@suse.de
- Update translations: de, es, fi, ja, and pt_BR; #350693.
* Tue Aug 21 2007 ro@suse.de
- completely comment out disabled subpacks
* Fri Aug  3 2007 ke@suse.de
- Add Arabian (ar), African (af, xh, and zu), and Indian (bn, gu, hi, mr,
  and ta) and Polish (pl); #281412 and SWAMPID 11144.
- Remove outdated yast translatations.
* Thu Oct 19 2006 jhargadon@suse.de
- added french translations for yelp and zen-updater for bug
  [#204335]
* Wed Oct  4 2006 jhargadon@suse.de
- initial submission of package
